import { loadableReady } from '@loadable/component';
import React from "react";
import { createRoot, hydrateRoot } from "react-dom/client";
import { Provider } from "react-redux";
import { BrowserRouter } from "react-router-dom";
import { getStore } from "./getStore.js";
import RouteContainer from "./components/RouteContainer/index.js";
import appState from "./libs/state.js";
export function bootstrap(pageRouter) {
    return async (id = "app") => {
        const AppJSX = (React.createElement(Provider, { serverState: window.__PRELOADED_STATE__, store: getStore() },
            React.createElement(BrowserRouter, null,
                React.createElement(RouteContainer, { pageRouter: pageRouter }))));
        const container = document.getElementById(id);
        let root;
        await loadableReady(() => {
            if (window.__onlyCSR__ === false) {
                root = hydrateRoot(container, AppJSX);
            }
            else {
                root = createRoot(container);
                root.render(AppJSX);
            }
        });
        appState.isClientBootstraped = true;
        return root;
    };
}
