import React from "react";
class CycleImage extends React.Component {
    style;
    stopPlay;
    constructor(props) {
        super(props);
        this.style = { width: this.props.width, height: this.props.height };
        this.state = { showIndex: 0 };
    }
    componentDidMount() {
        this.stopPlay = this.play(this.props.interval);
    }
    componentWillUnmount() {
        if (this.stopPlay) {
            this.stopPlay();
        }
    }
    render() {
        return (React.createElement("div", { style: {
                overflow: "hidden"
            } },
            React.createElement("div", null, this.props.images.map((imageSrc, index) => (React.createElement("img", { key: index, src: imageSrc, style: {
                    ...this.style,
                    display: this.canDisplay(index) ? "inline" : "none",
                } })))),
            React.createElement("p", null, "\u594B\u529B\u52A0\u8F7D\u4E2D\u2026")));
    }
    canDisplay(index) {
        return this.state.showIndex === index;
    }
    display(index) {
        this.setState({ showIndex: index });
    }
    play(interval, currentIndex = 0, state = { canPlay: true }) {
        if (currentIndex < this.props.images.length) {
            setTimeout(() => {
                if (state.canPlay) {
                    this.display(currentIndex);
                    this.play(interval, ++currentIndex, state);
                }
            }, interval);
        }
        return () => {
            state.canPlay = false;
        };
    }
}
export default CycleImage;
