import React from "react";
import { connect } from "../../connect.js";
import reducer from "./reducer.js";
import * as style from "./index.css";
export function Loading(props) {
    if (props.showLoading) {
        if (props.content) {
            if (typeof props.content === "string") {
                return (React.createElement("img", { className: style.loading, src: props.content }));
            }
            else if (props.content) {
                const CuzLoading = props.content;
                return React.createElement(CuzLoading, null);
            }
        }
        else {
            return (React.createElement("div", { className: `${style.loading} ${style.css}` }));
        }
    }
    return null;
}
export const getReducerName = (id) => {
    return id + ".common.loading";
};
export default function (id) {
    return connect()(Loading, reducer(id), getReducerName(id));
}
