import { connect as reduxConnect } from "react-redux";
import { registerRedux } from "./libs/metaCollector.js";
import getLogger from "./utils/logger.js";
const logger = getLogger().getLogger("iso/connect");
const componentEntityList = [];
const reducerEntityList = [];
const mizarConnect = function mizarConnect(mapStateToProps, mapDispatchToProps, mergeProps, options) {
    return (component, reducer, reducerName, subComponents) => {
        if (!mapStateToProps) {
            mapStateToProps = state => {
                return {
                    ...state[reducerName],
                };
            };
        }
        const reduxComponent = getReduxComponent(mapStateToProps, mapDispatchToProps, mergeProps, options, component);
        const findedReducerEntity = reducerEntityList.find(reducerEntity => (reducerEntity.component === component
            && reducerEntity.reducerName === reducerName
            && reducerEntity.reducer === reducer));
        if (!findedReducerEntity) {
            const sameComponentEntity = reducerEntityList.find(reducerEntity => reducerEntity.component === component);
            if (sameComponentEntity) {
                registerRedux(reducer, reducerName, reduxComponent, subComponents);
                reducerEntityList.push({ reducerName, reducer, component });
            }
            else {
                const sameReducerNameEntity = reducerEntityList.find(reducerEntity => reducerEntity.reducerName === reducerName);
                if (sameReducerNameEntity) {
                    logger.warn("reducer name重复了，该组件将不会注册入redux，请修改reducer name：", reducerName);
                }
                else {
                    registerRedux(reducer, reducerName, reduxComponent, subComponents);
                    reducerEntityList.push({ reducerName, reducer, component });
                }
            }
        }
        return reduxComponent;
    };
};
function getReduxComponent(mapStateToProps, mapDispatchToProps, mergeProps, options, component) {
    const findedComponentEntity = componentEntityList.find(componentEntity => componentEntity.component === component);
    if (findedComponentEntity) {
        return findedComponentEntity.reduxComponent;
    }
    else {
        const reduxComponent = reduxConnect(mapStateToProps, mapDispatchToProps, mergeProps, options)(component);
        componentEntityList.push({ reduxComponent, component });
        return reduxComponent;
    }
}
export { reduxConnect, mizarConnect as connect, };
