import { configureStore } from "@reduxjs/toolkit";
import { getRootReducer } from "./libs/metaCollector.js";
let store;
export function getStore() {
    if (store) {
        return store;
    }
    if (!IS_SERVER_RUNTIME) {
        const preloadedState = window.__PRELOADED_STATE__;
        delete window.__PRELOADED_STATE__;
        store = configureStore({
            reducer: getRootReducer(),
            devTools: process.env.NODE_ENV !== 'production',
            preloadedState,
        });
        return store;
    }
}
