import { matchRoutes } from "react-router-dom";
export function checkElementIsLoadable(element) {
    if (element && typeof element.preload === "function" && typeof element.load === "function") {
        return true;
    }
    return false;
}
export async function loadLoadableElement(element) {
    let RealCom;
    if (checkElementIsLoadable(element)) {
        RealCom = await element.load();
        return RealCom;
    }
    return element;
}
export default function (pageRouter, path) {
    const branch = matchRoutes(pageRouter, path);
    let matched = null;
    if (branch) {
        matched = branch[branch.length - 1];
    }
    return matched;
}
