let defaultLogger;
let isConfigured = false;
class Logger {
    suffix = "";
    supportMethods = ["log", "info", "warn", "error"];
    constructor(suffix) {
        this.suffix = suffix;
    }
    log(...args) {
        if (IS_DEBUG_MODE) {
            console.log(this.suffix, ...args);
        }
    }
    debug(...args) {
        this.log(...args);
    }
    info(...args) {
        this.log(...args);
    }
    warn(...args) {
        if (IS_DEBUG_MODE) {
            console.warn(this.suffix, ...args);
        }
    }
    error(...args) {
        console.error(this.suffix, ...args);
    }
}
export function setLogger(logger) {
    if (isConfigured) {
        console.warn("logger has been used, can not set");
        return;
    }
    defaultLogger = logger;
    isConfigured = true;
}
export default function getLogger() {
    if (!isConfigured) {
        defaultLogger = {
            getLogger: (suffix) => {
                return new Logger(suffix);
            }
        };
    }
    isConfigured = true;
    return defaultLogger;
}
