import getLogger from "./utils/logger.js";
import WebServer from "./index.js";
import { getApiRouter, getPageRouter } from "./libs/getRouter.js";
const logger = getLogger().getLogger("server/boostrap");
export function bootstrap(server = new WebServer({
    bodyParser: true,
    cookieParser: true,
})) {
    return async function (pageRouter, getMeta) {
        try {
            const apiRouter = await getApiRouter();
            if (apiRouter) {
                server.useRouter(apiRouter.getRouter());
            }
            const pr = await getPageRouter(pageRouter, getMeta);
            server.useRouter(pr.getRouter());
            await server.bootstrapAsync();
            return server;
        }
        catch (e) {
            logger.error("启动错误", e);
        }
    };
}
