import fs from "fs-extra";
const appConfJSON = fs.readJSONSync("./config/app.json");
let publicPath = "";
export function getPublicPath() {
    if (publicPath === "") {
        const cdn = IS_DEBUG_MODE ? '/' : getCDN();
        publicPath = `${cdn}${getAssetsPathPrefix()}client/`;
    }
    return publicPath;
}
export function getPort() {
    return getAppConf().port;
}
export function getCDN() {
    return getAppConf().cdn || "";
}
export function getAppConf() {
    return appConfJSON;
}
export function getAssetsPathPrefix() {
    let prefix = getAppConf().assetsPathPrefix;
    if (prefix && !prefix.endsWith("/")) {
        prefix += "/";
    }
    return prefix || '';
}
export function getPackageName() {
    return getAppConf.name || '';
}
